﻿//DESCRIPTION: Pseudo Vertical Align Center function
if (app.documents.length == 0 || app.selection.length == 0) { exit() }
processSelection(app.selection);

function processSelection(sel) {
if (sel.length > 1) {
processMultiSelection(sel);
} else {
vjcenterTextFrame(locateTF(sel[0]));
}

function processMultiSelection(sel) {
    for (var j = sel.length - 1; j >= 0; j--) {
        if (sel[j].constructor.name == "TextFrame") {
        vjcenterTextFrame(sel[j]);
        }
    }
}

function vjcenterTextFrame(tf) {
if (tf.textFramePreferences.textColumnCount > 1) {
// alert(«Multi-column text frames not supported»);
return
}
//save users measurement preferences
var userVert =  app.documents[0].viewPreferences.verticalMeasurementUnits;
app.documents[0].viewPreferences.verticalMeasurementUnits = MeasurementUnits.points;
var prevError = Number.POSITIVE_INFINITY;
var frameCenter = getFrameCenter(tf);
while (Math.abs(prevError) > 0.25) {
var textCenter = getTextCenter(tf);
var error = frameCenter - textCenter;
if (oscillating(error, prevError)) { return }
try {
tf.textFramePreferences.minimumFirstBaselineOffset += error;
} catch (e) { return }
prevError = error;
}
app.documents[0].viewPreferences.verticalMeasurementUnits = userVert;
}

function oscillating(err, olderr) {
if (Math.abs(olderr) > Math.abs(err)) { return false }
if (err * olderr >= 0)  { return false }
return true
}

function getTextCenter(tf) {
var topchar = tf.texts[0].characters[0];
var top = topchar.baseline - topchar.baselineShift - topchar.ascent;
var botline = tf.texts[0].lines[-1];
var bottom = botline.baseline + (botline.descent)*.66; // .66 derived empirically
return (top + bottom)/2;
}

function getFrameCenter(tf) {
var aBounds = tf.geometricBounds;
return (aBounds[0] + aBounds[2])/2
}

function locateTF(obj) {
    if (obj.constructor.name == "TextFrame") { return obj }
        try {
        return obj.parentTextFrames[0];
        } catch (e) {
        alert("Can’t locate text frame from selection.");
        }
    }
}